/// bezier.dart is a simple open-source library for handling 2D Bézier curve
/// math.
///
/// The library was developed, documented, and published by
/// [Aaron Barrett](http://www.aaronbarrett.com) and Isaac Barrett.  It is based
/// heavily on the work of [Pomax](https://pomax.github.io/), including his
/// excellent [Primer on Bézier Curves](https://pomax.github.io/bezierinfo/) and
/// his original JavaScript library,
/// [Bezier.js](https://pomax.github.io/bezierjs/).
library bezier;

export "src/bezier.dart";
export "src/bezier_slice.dart";
export "src/cubic_bezier.dart";
export "src/even_spacer.dart";
export "src/intersection.dart";
export "src/quadratic_bezier.dart";
